unit Applic;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, MultipleUndo, Menus;

type
  TApp = class(TForm)
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    InsertDate1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure InsertDate1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  App: TApp;

implementation

{$R *.dfm}

//Initialize the undo buffer (12 undo levels in this example)
procedure TApp.FormShow(Sender: TObject);
begin
   MultipleUndo.Initialize(12);
end;

//Clear the undo buffer
procedure TApp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MultipleUndo.Clear;
end;

//Key events that save an undo level into the undo buffer
procedure TApp.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_SPACE) then
  begin
    MultipleUndo.SaveToUndoBuffer(RichEdit1);
  end;
  if (Key = VK_RETURN) then
  begin
    MultipleUndo.SaveToUndoBuffer(RichEdit1);
  end;
  if (Key = VK_BACK) then
  begin
    MultipleUndo.SaveToUndoBuffer(RichEdit1);
  end;
  if (Key = VK_CLEAR) then
  begin
    MultipleUndo.SaveToUndoBuffer(RichEdit1);
  end;
  if (Key = VK_DELETE) then
  begin
    MultipleUndo.SaveToUndoBuffer(RichEdit1);
  end;
end;

//Events that save an undo level into the undo buffer
procedure TApp.Cut1Click(Sender: TObject);
begin
  MultipleUndo.SaveToUndoBuffer(RichEdit1);
  RichEdit1.CutToClipboard;
end;

procedure TApp.Copy1Click(Sender: TObject);
begin
  MultipleUndo.SaveToUndoBuffer(RichEdit1);
  RichEdit1.CopyToClipboard;
end;

procedure TApp.Paste1Click(Sender: TObject);
begin
  MultipleUndo.SaveToUndoBuffer(RichEdit1);
  RichEdit1.PasteFromClipboard;
end;

procedure TApp.InsertDate1Click(Sender: TObject);
begin
  MultipleUndo.SaveToUndoBuffer(RichEdit1);
  RichEdit1.SelText := FormatDateTime('yyyy-mm-dd', Date);
end;

//Undo and redo
procedure TApp.Undo1Click(Sender: TObject);
begin
  MultipleUndo.LoadFromUndoBuffer(RichEdit1, true);
end;

procedure TApp.Redo1Click(Sender: TObject);
begin
  MultipleUndo.LoadFromUndoBuffer(RichEdit1, false);
end;

end.

